#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
#[doc(alias = "VK_KHR_TIMELINE_SEMAPHORE_SPEC_VERSION")]
pub const KHR_TIMELINE_SEMAPHORE_SPEC_VERSION: u32 = 2;
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
#[doc(alias = "VK_KHR_TIMELINE_SEMAPHORE_EXTENSION_NAME")]
pub const KHR_TIMELINE_SEMAPHORE_EXTENSION_NAME: *const std::os::raw::c_char = crate::cstr!("VK_KHR_timeline_semaphore");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_GET_SEMAPHORE_COUNTER_VALUE_KHR: *const std::os::raw::c_char = crate::cstr!("vkGetSemaphoreCounterValueKHR");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_WAIT_SEMAPHORES_KHR: *const std::os::raw::c_char = crate::cstr!("vkWaitSemaphoresKHR");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_SIGNAL_SEMAPHORE_KHR: *const std::os::raw::c_char = crate::cstr!("vkSignalSemaphoreKHR");
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkSemaphoreWaitFlagsKHR.html)) · Alias <br/> VkSemaphoreWaitFlags - Bitmask of VkSemaphoreWaitFlagBits\n[](#_c_specification)C Specification\n----------\n\n```\n// Provided by VK_VERSION_1_2\ntypedef VkFlags VkSemaphoreWaitFlags;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_timeline_semaphore\ntypedef VkSemaphoreWaitFlags VkSemaphoreWaitFlagsKHR;\n```\n[](#_description)Description\n----------\n\n[`crate::vk::SemaphoreWaitFlagBits`] is a bitmask type for setting a mask of zero or\nmore [VkSemaphoreWaitFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkSemaphoreWaitFlagBits.html).\n[](#_see_also)See Also\n----------\n\n[VkSemaphoreWaitFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkSemaphoreWaitFlagBits.html), [`crate::vk::SemaphoreWaitInfo`]\n"]
#[doc(alias = "VkSemaphoreWaitFlagsKHR")]
#[allow(non_camel_case_types)]
pub type SemaphoreWaitFlagsKHR = crate::vk1_2::SemaphoreWaitFlags;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkSemaphoreTypeKHR.html)) · Alias <br/> VkSemaphoreType - Sepcifies the type of a semaphore object\n[](#_c_specification)C Specification\n----------\n\nPossible values of [`crate::vk::SemaphoreTypeCreateInfo::semaphore_type`],\nspecifying the type of a semaphore, are:\n\n```\n// Provided by VK_VERSION_1_2\ntypedef enum VkSemaphoreType {\n    VK_SEMAPHORE_TYPE_BINARY = 0,\n    VK_SEMAPHORE_TYPE_TIMELINE = 1,\n  // Provided by VK_KHR_timeline_semaphore\n    VK_SEMAPHORE_TYPE_BINARY_KHR = VK_SEMAPHORE_TYPE_BINARY,\n  // Provided by VK_KHR_timeline_semaphore\n    VK_SEMAPHORE_TYPE_TIMELINE_KHR = VK_SEMAPHORE_TYPE_TIMELINE,\n} VkSemaphoreType;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_timeline_semaphore\ntypedef VkSemaphoreType VkSemaphoreTypeKHR;\n```\n[](#_description)Description\n----------\n\n* [`crate::vk::SemaphoreType::BINARY`] specifies a *binary semaphore* type that\n  has a boolean payload indicating whether the semaphore is currently\n  signaled or unsignaled.\n  When created, the semaphore is in the unsignaled state.\n\n* [`crate::vk::SemaphoreType::TIMELINE`] specifies a *timeline semaphore* type\n  that has a strictly increasing 64-bit unsigned integer payload\n  indicating whether the semaphore is signaled with respect to a\n  particular reference value.\n  When created, the semaphore payload has the value given by the`initialValue` field of [`crate::vk::SemaphoreTypeCreateInfo`].\n[](#_see_also)See Also\n----------\n\n[`crate::vk::SemaphoreTypeCreateInfo`]\n"]
#[doc(alias = "VkSemaphoreTypeKHR")]
#[allow(non_camel_case_types)]
pub type SemaphoreTypeKHR = crate::vk1_2::SemaphoreType;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkSemaphoreWaitFlagBitsKHR.html)) · Alias <br/> VkSemaphoreWaitFlagBits - Bitmask specifying additional parameters of a semaphore wait operation\n[](#_c_specification)C Specification\n----------\n\nBits which **can** be set in [`crate::vk::SemaphoreWaitInfo::flags`], specifying\nadditional parameters of a semaphore wait operation, are:\n\n```\n// Provided by VK_VERSION_1_2\ntypedef enum VkSemaphoreWaitFlagBits {\n    VK_SEMAPHORE_WAIT_ANY_BIT = 0x00000001,\n  // Provided by VK_KHR_timeline_semaphore\n    VK_SEMAPHORE_WAIT_ANY_BIT_KHR = VK_SEMAPHORE_WAIT_ANY_BIT,\n} VkSemaphoreWaitFlagBits;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_timeline_semaphore\ntypedef VkSemaphoreWaitFlagBits VkSemaphoreWaitFlagBitsKHR;\n```\n[](#_description)Description\n----------\n\n* [`crate::vk::SemaphoreWaitFlagBits::ANY`] specifies that the semaphore wait\n  condition is that at least one of the semaphores in[`crate::vk::SemaphoreWaitInfo`]::`pSemaphores` has reached the value\n  specified by the corresponding element of[`crate::vk::SemaphoreWaitInfo`]::`pValues`.\n  If [`crate::vk::SemaphoreWaitFlagBits::ANY`] is not set, the semaphore wait\n  condition is that all of the semaphores in[`crate::vk::SemaphoreWaitInfo`]::`pSemaphores` have reached the value\n  specified by the corresponding element of[`crate::vk::SemaphoreWaitInfo`]::`pValues`.\n[](#_see_also)See Also\n----------\n\n[`crate::vk::SemaphoreWaitFlagBits`]\n"]
#[doc(alias = "VkSemaphoreWaitFlagBitsKHR")]
#[allow(non_camel_case_types)]
pub type SemaphoreWaitFlagBitsKHR = crate::vk1_2::SemaphoreWaitFlagBits;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkPhysicalDeviceTimelineSemaphoreFeaturesKHR.html)) · Alias <br/> VkPhysicalDeviceTimelineSemaphoreFeatures - Structure describing timeline semaphore features that can be supported by an implementation\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::PhysicalDeviceTimelineSemaphoreFeatures`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_2\ntypedef struct VkPhysicalDeviceTimelineSemaphoreFeatures {\n    VkStructureType    sType;\n    void*              pNext;\n    VkBool32           timelineSemaphore;\n} VkPhysicalDeviceTimelineSemaphoreFeatures;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_timeline_semaphore\ntypedef VkPhysicalDeviceTimelineSemaphoreFeatures VkPhysicalDeviceTimelineSemaphoreFeaturesKHR;\n```\n[](#_members)Members\n----------\n\nThis structure describes the following feature:\n[](#_description)Description\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* []() `timelineSemaphore`indicates whether semaphores created with a [`crate::vk::SemaphoreType`] of[`crate::vk::SemaphoreType::TIMELINE`] are supported.\n\nIf the [`crate::vk::PhysicalDeviceTimelineSemaphoreFeatures`] structure is included in the `pNext` chain of the[`crate::vk::PhysicalDeviceFeatures2`] structure passed to[`crate::vk::PFN_vkGetPhysicalDeviceFeatures2`], it is filled in to indicate whether each\ncorresponding feature is supported.[`crate::vk::PhysicalDeviceTimelineSemaphoreFeatures`] **can** also be used in the `pNext` chain of[`crate::vk::DeviceCreateInfo`] to selectively enable these features.\n\nValid Usage (Implicit)\n\n* []() VUID-VkPhysicalDeviceTimelineSemaphoreFeatures-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::PHYSICAL_DEVICE_TIMELINE_SEMAPHORE_FEATURES`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Bool32`], [`crate::vk::StructureType`]\n"]
#[doc(alias = "VkPhysicalDeviceTimelineSemaphoreFeaturesKHR")]
#[allow(non_camel_case_types)]
pub type PhysicalDeviceTimelineSemaphoreFeaturesKHR = crate::vk1_2::PhysicalDeviceTimelineSemaphoreFeatures;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkPhysicalDeviceTimelineSemaphoreFeaturesKHR.html)) · Alias <br/> VkPhysicalDeviceTimelineSemaphoreFeatures - Structure describing timeline semaphore features that can be supported by an implementation\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::PhysicalDeviceTimelineSemaphoreFeatures`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_2\ntypedef struct VkPhysicalDeviceTimelineSemaphoreFeatures {\n    VkStructureType    sType;\n    void*              pNext;\n    VkBool32           timelineSemaphore;\n} VkPhysicalDeviceTimelineSemaphoreFeatures;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_timeline_semaphore\ntypedef VkPhysicalDeviceTimelineSemaphoreFeatures VkPhysicalDeviceTimelineSemaphoreFeaturesKHR;\n```\n[](#_members)Members\n----------\n\nThis structure describes the following feature:\n[](#_description)Description\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* []() `timelineSemaphore`indicates whether semaphores created with a [`crate::vk::SemaphoreType`] of[`crate::vk::SemaphoreType::TIMELINE`] are supported.\n\nIf the [`crate::vk::PhysicalDeviceTimelineSemaphoreFeatures`] structure is included in the `pNext` chain of the[`crate::vk::PhysicalDeviceFeatures2`] structure passed to[`crate::vk::PFN_vkGetPhysicalDeviceFeatures2`], it is filled in to indicate whether each\ncorresponding feature is supported.[`crate::vk::PhysicalDeviceTimelineSemaphoreFeatures`] **can** also be used in the `pNext` chain of[`crate::vk::DeviceCreateInfo`] to selectively enable these features.\n\nValid Usage (Implicit)\n\n* []() VUID-VkPhysicalDeviceTimelineSemaphoreFeatures-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::PHYSICAL_DEVICE_TIMELINE_SEMAPHORE_FEATURES`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Bool32`], [`crate::vk::StructureType`]\n"]
#[doc(alias = "VkPhysicalDeviceTimelineSemaphoreFeaturesKHR")]
#[allow(non_camel_case_types)]
pub type PhysicalDeviceTimelineSemaphoreFeaturesKHRBuilder<'a> = crate::vk1_2::PhysicalDeviceTimelineSemaphoreFeaturesBuilder<'a>;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkPhysicalDeviceTimelineSemaphorePropertiesKHR.html)) · Alias <br/> VkPhysicalDeviceTimelineSemaphoreProperties - Structure describing timeline semaphore properties that can be supported by an implementation\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::PhysicalDeviceTimelineSemaphoreProperties`] structure is defined\nas:\n\n```\n// Provided by VK_VERSION_1_2\ntypedef struct VkPhysicalDeviceTimelineSemaphoreProperties {\n    VkStructureType    sType;\n    void*              pNext;\n    uint64_t           maxTimelineSemaphoreValueDifference;\n} VkPhysicalDeviceTimelineSemaphoreProperties;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_timeline_semaphore\ntypedef VkPhysicalDeviceTimelineSemaphoreProperties VkPhysicalDeviceTimelineSemaphorePropertiesKHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n[](#_description)Description\n----------\n\n* []()`maxTimelineSemaphoreValueDifference` indicates the maximum\n  difference allowed by the implementation between the current value of a\n  timeline semaphore and any pending signal or wait operations.\n\nIf the [`crate::vk::PhysicalDeviceTimelineSemaphoreProperties`] structure is included in the `pNext` chain of the[`crate::vk::PhysicalDeviceProperties2`] structure passed to[`crate::vk::PFN_vkGetPhysicalDeviceProperties2`], it is filled in with each\ncorresponding implementation-dependent property.\n\nValid Usage (Implicit)\n\n* []() VUID-VkPhysicalDeviceTimelineSemaphoreProperties-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::PHYSICAL_DEVICE_TIMELINE_SEMAPHORE_PROPERTIES`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::StructureType`]\n"]
#[doc(alias = "VkPhysicalDeviceTimelineSemaphorePropertiesKHR")]
#[allow(non_camel_case_types)]
pub type PhysicalDeviceTimelineSemaphorePropertiesKHR = crate::vk1_2::PhysicalDeviceTimelineSemaphoreProperties;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkPhysicalDeviceTimelineSemaphorePropertiesKHR.html)) · Alias <br/> VkPhysicalDeviceTimelineSemaphoreProperties - Structure describing timeline semaphore properties that can be supported by an implementation\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::PhysicalDeviceTimelineSemaphoreProperties`] structure is defined\nas:\n\n```\n// Provided by VK_VERSION_1_2\ntypedef struct VkPhysicalDeviceTimelineSemaphoreProperties {\n    VkStructureType    sType;\n    void*              pNext;\n    uint64_t           maxTimelineSemaphoreValueDifference;\n} VkPhysicalDeviceTimelineSemaphoreProperties;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_timeline_semaphore\ntypedef VkPhysicalDeviceTimelineSemaphoreProperties VkPhysicalDeviceTimelineSemaphorePropertiesKHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n[](#_description)Description\n----------\n\n* []()`maxTimelineSemaphoreValueDifference` indicates the maximum\n  difference allowed by the implementation between the current value of a\n  timeline semaphore and any pending signal or wait operations.\n\nIf the [`crate::vk::PhysicalDeviceTimelineSemaphoreProperties`] structure is included in the `pNext` chain of the[`crate::vk::PhysicalDeviceProperties2`] structure passed to[`crate::vk::PFN_vkGetPhysicalDeviceProperties2`], it is filled in with each\ncorresponding implementation-dependent property.\n\nValid Usage (Implicit)\n\n* []() VUID-VkPhysicalDeviceTimelineSemaphoreProperties-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::PHYSICAL_DEVICE_TIMELINE_SEMAPHORE_PROPERTIES`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::StructureType`]\n"]
#[doc(alias = "VkPhysicalDeviceTimelineSemaphorePropertiesKHR")]
#[allow(non_camel_case_types)]
pub type PhysicalDeviceTimelineSemaphorePropertiesKHRBuilder<'a> = crate::vk1_2::PhysicalDeviceTimelineSemaphorePropertiesBuilder<'a>;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkSemaphoreTypeCreateInfoKHR.html)) · Alias <br/> VkSemaphoreTypeCreateInfo - Structure specifying the type of a newly created semaphore\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::SemaphoreTypeCreateInfo`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_2\ntypedef struct VkSemaphoreTypeCreateInfo {\n    VkStructureType    sType;\n    const void*        pNext;\n    VkSemaphoreType    semaphoreType;\n    uint64_t           initialValue;\n} VkSemaphoreTypeCreateInfo;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_timeline_semaphore\ntypedef VkSemaphoreTypeCreateInfo VkSemaphoreTypeCreateInfoKHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `semaphoreType` is a [`crate::vk::SemaphoreType`] value specifying the type\n  of the semaphore.\n\n* `initialValue` is the initial payload value if `semaphoreType`is [`crate::vk::SemaphoreType::TIMELINE`].\n[](#_description)Description\n----------\n\nTo create a semaphore of a specific type, add a[`crate::vk::SemaphoreTypeCreateInfo`] structure to the[`crate::vk::SemaphoreCreateInfo::p_next`] chain.\n\nIf no [`crate::vk::SemaphoreTypeCreateInfo`] structure is included in the`pNext` chain of [`crate::vk::SemaphoreCreateInfo`], then the created semaphore\nwill have a default [`crate::vk::SemaphoreType`] of [`crate::vk::SemaphoreType::BINARY`].\n\nValid Usage\n\n* []() VUID-VkSemaphoreTypeCreateInfo-timelineSemaphore-03252  \n   If the [`timelineSemaphore`](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#features-timelineSemaphore) feature is\n  not enabled, `semaphoreType` **must** not equal[`crate::vk::SemaphoreType::TIMELINE`]\n\n* []() VUID-VkSemaphoreTypeCreateInfo-semaphoreType-03279  \n   If `semaphoreType` is [`crate::vk::SemaphoreType::BINARY`],`initialValue` **must** be zero\n\nValid Usage (Implicit)\n\n* []() VUID-VkSemaphoreTypeCreateInfo-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::SEMAPHORE_TYPE_CREATE_INFO`]\n\n* []() VUID-VkSemaphoreTypeCreateInfo-semaphoreType-parameter  \n  `semaphoreType` **must** be a valid [`crate::vk::SemaphoreType`] value\n[](#_see_also)See Also\n----------\n\n[`crate::vk::SemaphoreType`], [`crate::vk::StructureType`]\n"]
#[doc(alias = "VkSemaphoreTypeCreateInfoKHR")]
#[allow(non_camel_case_types)]
pub type SemaphoreTypeCreateInfoKHR = crate::vk1_2::SemaphoreTypeCreateInfo;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkSemaphoreTypeCreateInfoKHR.html)) · Alias <br/> VkSemaphoreTypeCreateInfo - Structure specifying the type of a newly created semaphore\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::SemaphoreTypeCreateInfo`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_2\ntypedef struct VkSemaphoreTypeCreateInfo {\n    VkStructureType    sType;\n    const void*        pNext;\n    VkSemaphoreType    semaphoreType;\n    uint64_t           initialValue;\n} VkSemaphoreTypeCreateInfo;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_timeline_semaphore\ntypedef VkSemaphoreTypeCreateInfo VkSemaphoreTypeCreateInfoKHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `semaphoreType` is a [`crate::vk::SemaphoreType`] value specifying the type\n  of the semaphore.\n\n* `initialValue` is the initial payload value if `semaphoreType`is [`crate::vk::SemaphoreType::TIMELINE`].\n[](#_description)Description\n----------\n\nTo create a semaphore of a specific type, add a[`crate::vk::SemaphoreTypeCreateInfo`] structure to the[`crate::vk::SemaphoreCreateInfo::p_next`] chain.\n\nIf no [`crate::vk::SemaphoreTypeCreateInfo`] structure is included in the`pNext` chain of [`crate::vk::SemaphoreCreateInfo`], then the created semaphore\nwill have a default [`crate::vk::SemaphoreType`] of [`crate::vk::SemaphoreType::BINARY`].\n\nValid Usage\n\n* []() VUID-VkSemaphoreTypeCreateInfo-timelineSemaphore-03252  \n   If the [`timelineSemaphore`](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#features-timelineSemaphore) feature is\n  not enabled, `semaphoreType` **must** not equal[`crate::vk::SemaphoreType::TIMELINE`]\n\n* []() VUID-VkSemaphoreTypeCreateInfo-semaphoreType-03279  \n   If `semaphoreType` is [`crate::vk::SemaphoreType::BINARY`],`initialValue` **must** be zero\n\nValid Usage (Implicit)\n\n* []() VUID-VkSemaphoreTypeCreateInfo-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::SEMAPHORE_TYPE_CREATE_INFO`]\n\n* []() VUID-VkSemaphoreTypeCreateInfo-semaphoreType-parameter  \n  `semaphoreType` **must** be a valid [`crate::vk::SemaphoreType`] value\n[](#_see_also)See Also\n----------\n\n[`crate::vk::SemaphoreType`], [`crate::vk::StructureType`]\n"]
#[doc(alias = "VkSemaphoreTypeCreateInfoKHR")]
#[allow(non_camel_case_types)]
pub type SemaphoreTypeCreateInfoKHRBuilder<'a> = crate::vk1_2::SemaphoreTypeCreateInfoBuilder<'a>;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkTimelineSemaphoreSubmitInfoKHR.html)) · Alias <br/> VkTimelineSemaphoreSubmitInfo - Structure specifying signal and wait values for timeline semaphores\n[](#_c_specification)C Specification\n----------\n\nTo specify the values to use when waiting for and signaling semaphores\ncreated with a [`crate::vk::SemaphoreType`] of [`crate::vk::SemaphoreType::TIMELINE`],\nadd a [`crate::vk::TimelineSemaphoreSubmitInfo`] structure to the `pNext` chain\nof the [`crate::vk::SubmitInfo`] structure when using [`crate::vk::PFN_vkQueueSubmit`] or the[`crate::vk::BindSparseInfo`] structure when using [`crate::vk::PFN_vkQueueBindSparse`].\nThe [`crate::vk::TimelineSemaphoreSubmitInfo`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_2\ntypedef struct VkTimelineSemaphoreSubmitInfo {\n    VkStructureType    sType;\n    const void*        pNext;\n    uint32_t           waitSemaphoreValueCount;\n    const uint64_t*    pWaitSemaphoreValues;\n    uint32_t           signalSemaphoreValueCount;\n    const uint64_t*    pSignalSemaphoreValues;\n} VkTimelineSemaphoreSubmitInfo;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_timeline_semaphore\ntypedef VkTimelineSemaphoreSubmitInfo VkTimelineSemaphoreSubmitInfoKHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `waitSemaphoreValueCount` is the number of semaphore wait values\n  specified in `pWaitSemaphoreValues`.\n\n* `pWaitSemaphoreValues` is a pointer to an array of`waitSemaphoreValueCount` values for the corresponding semaphores in[`crate::vk::SubmitInfo::p_wait_semaphores`] to wait for.\n\n* `signalSemaphoreValueCount` is the number of semaphore signal values\n  specified in `pSignalSemaphoreValues`.\n\n* `pSignalSemaphoreValues` is a pointer to an array`signalSemaphoreValueCount` values for the corresponding semaphores\n  in [`crate::vk::SubmitInfo::p_signal_semaphores`] to set when signaled.\n[](#_description)Description\n----------\n\nIf the semaphore in [`crate::vk::SubmitInfo::p_wait_semaphores`] or[`crate::vk::SubmitInfo::p_signal_semaphores`] corresponding to an entry in`pWaitSemaphoreValues` or `pSignalSemaphoreValues` respectively was\nnot created with a [`crate::vk::SemaphoreType`] of[`crate::vk::SemaphoreType::TIMELINE`], the implementation **must** ignore the value\nin the `pWaitSemaphoreValues` or `pSignalSemaphoreValues` entry.\n\nValid Usage (Implicit)\n\n* []() VUID-VkTimelineSemaphoreSubmitInfo-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::TIMELINE_SEMAPHORE_SUBMIT_INFO`]\n\n* []() VUID-VkTimelineSemaphoreSubmitInfo-pWaitSemaphoreValues-parameter  \n   If `waitSemaphoreValueCount` is not `0`, and `pWaitSemaphoreValues` is not `NULL`, `pWaitSemaphoreValues` **must** be a valid pointer to an array of `waitSemaphoreValueCount` `uint64_t` values\n\n* []() VUID-VkTimelineSemaphoreSubmitInfo-pSignalSemaphoreValues-parameter  \n   If `signalSemaphoreValueCount` is not `0`, and `pSignalSemaphoreValues` is not `NULL`, `pSignalSemaphoreValues` **must** be a valid pointer to an array of `signalSemaphoreValueCount` `uint64_t` values\n[](#_see_also)See Also\n----------\n\n[`crate::vk::StructureType`]\n"]
#[doc(alias = "VkTimelineSemaphoreSubmitInfoKHR")]
#[allow(non_camel_case_types)]
pub type TimelineSemaphoreSubmitInfoKHR = crate::vk1_2::TimelineSemaphoreSubmitInfo;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkTimelineSemaphoreSubmitInfoKHR.html)) · Alias <br/> VkTimelineSemaphoreSubmitInfo - Structure specifying signal and wait values for timeline semaphores\n[](#_c_specification)C Specification\n----------\n\nTo specify the values to use when waiting for and signaling semaphores\ncreated with a [`crate::vk::SemaphoreType`] of [`crate::vk::SemaphoreType::TIMELINE`],\nadd a [`crate::vk::TimelineSemaphoreSubmitInfo`] structure to the `pNext` chain\nof the [`crate::vk::SubmitInfo`] structure when using [`crate::vk::PFN_vkQueueSubmit`] or the[`crate::vk::BindSparseInfo`] structure when using [`crate::vk::PFN_vkQueueBindSparse`].\nThe [`crate::vk::TimelineSemaphoreSubmitInfo`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_2\ntypedef struct VkTimelineSemaphoreSubmitInfo {\n    VkStructureType    sType;\n    const void*        pNext;\n    uint32_t           waitSemaphoreValueCount;\n    const uint64_t*    pWaitSemaphoreValues;\n    uint32_t           signalSemaphoreValueCount;\n    const uint64_t*    pSignalSemaphoreValues;\n} VkTimelineSemaphoreSubmitInfo;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_timeline_semaphore\ntypedef VkTimelineSemaphoreSubmitInfo VkTimelineSemaphoreSubmitInfoKHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `waitSemaphoreValueCount` is the number of semaphore wait values\n  specified in `pWaitSemaphoreValues`.\n\n* `pWaitSemaphoreValues` is a pointer to an array of`waitSemaphoreValueCount` values for the corresponding semaphores in[`crate::vk::SubmitInfo::p_wait_semaphores`] to wait for.\n\n* `signalSemaphoreValueCount` is the number of semaphore signal values\n  specified in `pSignalSemaphoreValues`.\n\n* `pSignalSemaphoreValues` is a pointer to an array`signalSemaphoreValueCount` values for the corresponding semaphores\n  in [`crate::vk::SubmitInfo::p_signal_semaphores`] to set when signaled.\n[](#_description)Description\n----------\n\nIf the semaphore in [`crate::vk::SubmitInfo::p_wait_semaphores`] or[`crate::vk::SubmitInfo::p_signal_semaphores`] corresponding to an entry in`pWaitSemaphoreValues` or `pSignalSemaphoreValues` respectively was\nnot created with a [`crate::vk::SemaphoreType`] of[`crate::vk::SemaphoreType::TIMELINE`], the implementation **must** ignore the value\nin the `pWaitSemaphoreValues` or `pSignalSemaphoreValues` entry.\n\nValid Usage (Implicit)\n\n* []() VUID-VkTimelineSemaphoreSubmitInfo-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::TIMELINE_SEMAPHORE_SUBMIT_INFO`]\n\n* []() VUID-VkTimelineSemaphoreSubmitInfo-pWaitSemaphoreValues-parameter  \n   If `waitSemaphoreValueCount` is not `0`, and `pWaitSemaphoreValues` is not `NULL`, `pWaitSemaphoreValues` **must** be a valid pointer to an array of `waitSemaphoreValueCount` `uint64_t` values\n\n* []() VUID-VkTimelineSemaphoreSubmitInfo-pSignalSemaphoreValues-parameter  \n   If `signalSemaphoreValueCount` is not `0`, and `pSignalSemaphoreValues` is not `NULL`, `pSignalSemaphoreValues` **must** be a valid pointer to an array of `signalSemaphoreValueCount` `uint64_t` values\n[](#_see_also)See Also\n----------\n\n[`crate::vk::StructureType`]\n"]
#[doc(alias = "VkTimelineSemaphoreSubmitInfoKHR")]
#[allow(non_camel_case_types)]
pub type TimelineSemaphoreSubmitInfoKHRBuilder<'a> = crate::vk1_2::TimelineSemaphoreSubmitInfoBuilder<'a>;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkSemaphoreWaitInfoKHR.html)) · Alias <br/> VkSemaphoreWaitInfo - Structure containing information about the semaphore wait condition\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::SemaphoreWaitInfo`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_2\ntypedef struct VkSemaphoreWaitInfo {\n    VkStructureType         sType;\n    const void*             pNext;\n    VkSemaphoreWaitFlags    flags;\n    uint32_t                semaphoreCount;\n    const VkSemaphore*      pSemaphores;\n    const uint64_t*         pValues;\n} VkSemaphoreWaitInfo;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_timeline_semaphore\ntypedef VkSemaphoreWaitInfo VkSemaphoreWaitInfoKHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `flags` is a bitmask of [VkSemaphoreWaitFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkSemaphoreWaitFlagBits.html) specifying\n  additional parameters for the semaphore wait operation.\n\n* `semaphoreCount` is the number of semaphores to wait on.\n\n* `pSemaphores` is a pointer to an array of `semaphoreCount`semaphore handles to wait on.\n\n* `pValues` is a pointer to an array of `semaphoreCount` timeline\n  semaphore values.\n[](#_description)Description\n----------\n\nValid Usage\n\n* []() VUID-VkSemaphoreWaitInfo-pSemaphores-03256  \n   All of the elements of `pSemaphores` **must** reference a semaphore\n  that was created with a [`crate::vk::SemaphoreType`] of[`crate::vk::SemaphoreType::TIMELINE`]\n\nValid Usage (Implicit)\n\n* []() VUID-VkSemaphoreWaitInfo-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::SEMAPHORE_WAIT_INFO`]\n\n* []() VUID-VkSemaphoreWaitInfo-pNext-pNext  \n  `pNext` **must** be `NULL`\n\n* []() VUID-VkSemaphoreWaitInfo-flags-parameter  \n  `flags` **must** be a valid combination of [VkSemaphoreWaitFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkSemaphoreWaitFlagBits.html) values\n\n* []() VUID-VkSemaphoreWaitInfo-pSemaphores-parameter  \n  `pSemaphores` **must** be a valid pointer to an array of `semaphoreCount` valid [`crate::vk::Semaphore`] handles\n\n* []() VUID-VkSemaphoreWaitInfo-pValues-parameter  \n  `pValues` **must** be a valid pointer to an array of `semaphoreCount` `uint64_t` values\n\n* []() VUID-VkSemaphoreWaitInfo-semaphoreCount-arraylength  \n  `semaphoreCount` **must** be greater than `0`\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Semaphore`], [`crate::vk::SemaphoreWaitFlagBits`], [`crate::vk::StructureType`], [`crate::vk::PFN_vkWaitSemaphores`], [`crate::vk::PFN_vkWaitSemaphores`]\n"]
#[doc(alias = "VkSemaphoreWaitInfoKHR")]
#[allow(non_camel_case_types)]
pub type SemaphoreWaitInfoKHR = crate::vk1_2::SemaphoreWaitInfo;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkSemaphoreWaitInfoKHR.html)) · Alias <br/> VkSemaphoreWaitInfo - Structure containing information about the semaphore wait condition\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::SemaphoreWaitInfo`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_2\ntypedef struct VkSemaphoreWaitInfo {\n    VkStructureType         sType;\n    const void*             pNext;\n    VkSemaphoreWaitFlags    flags;\n    uint32_t                semaphoreCount;\n    const VkSemaphore*      pSemaphores;\n    const uint64_t*         pValues;\n} VkSemaphoreWaitInfo;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_timeline_semaphore\ntypedef VkSemaphoreWaitInfo VkSemaphoreWaitInfoKHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `flags` is a bitmask of [VkSemaphoreWaitFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkSemaphoreWaitFlagBits.html) specifying\n  additional parameters for the semaphore wait operation.\n\n* `semaphoreCount` is the number of semaphores to wait on.\n\n* `pSemaphores` is a pointer to an array of `semaphoreCount`semaphore handles to wait on.\n\n* `pValues` is a pointer to an array of `semaphoreCount` timeline\n  semaphore values.\n[](#_description)Description\n----------\n\nValid Usage\n\n* []() VUID-VkSemaphoreWaitInfo-pSemaphores-03256  \n   All of the elements of `pSemaphores` **must** reference a semaphore\n  that was created with a [`crate::vk::SemaphoreType`] of[`crate::vk::SemaphoreType::TIMELINE`]\n\nValid Usage (Implicit)\n\n* []() VUID-VkSemaphoreWaitInfo-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::SEMAPHORE_WAIT_INFO`]\n\n* []() VUID-VkSemaphoreWaitInfo-pNext-pNext  \n  `pNext` **must** be `NULL`\n\n* []() VUID-VkSemaphoreWaitInfo-flags-parameter  \n  `flags` **must** be a valid combination of [VkSemaphoreWaitFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkSemaphoreWaitFlagBits.html) values\n\n* []() VUID-VkSemaphoreWaitInfo-pSemaphores-parameter  \n  `pSemaphores` **must** be a valid pointer to an array of `semaphoreCount` valid [`crate::vk::Semaphore`] handles\n\n* []() VUID-VkSemaphoreWaitInfo-pValues-parameter  \n  `pValues` **must** be a valid pointer to an array of `semaphoreCount` `uint64_t` values\n\n* []() VUID-VkSemaphoreWaitInfo-semaphoreCount-arraylength  \n  `semaphoreCount` **must** be greater than `0`\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Semaphore`], [`crate::vk::SemaphoreWaitFlagBits`], [`crate::vk::StructureType`], [`crate::vk::PFN_vkWaitSemaphores`], [`crate::vk::PFN_vkWaitSemaphores`]\n"]
#[doc(alias = "VkSemaphoreWaitInfoKHR")]
#[allow(non_camel_case_types)]
pub type SemaphoreWaitInfoKHRBuilder<'a> = crate::vk1_2::SemaphoreWaitInfoBuilder<'a>;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkSemaphoreSignalInfoKHR.html)) · Alias <br/> VkSemaphoreSignalInfo - Structure containing information about a semaphore signal operation\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::SemaphoreSignalInfo`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_2\ntypedef struct VkSemaphoreSignalInfo {\n    VkStructureType    sType;\n    const void*        pNext;\n    VkSemaphore        semaphore;\n    uint64_t           value;\n} VkSemaphoreSignalInfo;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_timeline_semaphore\ntypedef VkSemaphoreSignalInfo VkSemaphoreSignalInfoKHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `semaphore` is the handle of the semaphore to signal.\n\n* `value` is the value to signal.\n[](#_description)Description\n----------\n\nValid Usage\n\n* []() VUID-VkSemaphoreSignalInfo-semaphore-03257  \n  `semaphore` **must** have been created with a [`crate::vk::SemaphoreType`] of[`crate::vk::SemaphoreType::TIMELINE`]\n\n* []() VUID-VkSemaphoreSignalInfo-value-03258  \n  `value` **must** have a value greater than the current value of the\n  semaphore\n\n* []() VUID-VkSemaphoreSignalInfo-value-03259  \n  `value` **must** be less than the value of any pending semaphore signal\n  operations\n\n* []() VUID-VkSemaphoreSignalInfo-value-03260  \n  `value` **must** have a value which does not differ from the current\n  value of the semaphore or the value of any outstanding semaphore wait or\n  signal operation on `semaphore` by more than[`maxTimelineSemaphoreValueDifference`](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#limits-maxTimelineSemaphoreValueDifference)\n\nValid Usage (Implicit)\n\n* []() VUID-VkSemaphoreSignalInfo-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::SEMAPHORE_SIGNAL_INFO`]\n\n* []() VUID-VkSemaphoreSignalInfo-pNext-pNext  \n  `pNext` **must** be `NULL`\n\n* []() VUID-VkSemaphoreSignalInfo-semaphore-parameter  \n  `semaphore` **must** be a valid [`crate::vk::Semaphore`] handle\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Semaphore`], [`crate::vk::StructureType`], [`crate::vk::PFN_vkSignalSemaphore`], [`crate::vk::PFN_vkSignalSemaphore`]\n"]
#[doc(alias = "VkSemaphoreSignalInfoKHR")]
#[allow(non_camel_case_types)]
pub type SemaphoreSignalInfoKHR = crate::vk1_2::SemaphoreSignalInfo;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkSemaphoreSignalInfoKHR.html)) · Alias <br/> VkSemaphoreSignalInfo - Structure containing information about a semaphore signal operation\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::SemaphoreSignalInfo`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_2\ntypedef struct VkSemaphoreSignalInfo {\n    VkStructureType    sType;\n    const void*        pNext;\n    VkSemaphore        semaphore;\n    uint64_t           value;\n} VkSemaphoreSignalInfo;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_timeline_semaphore\ntypedef VkSemaphoreSignalInfo VkSemaphoreSignalInfoKHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `semaphore` is the handle of the semaphore to signal.\n\n* `value` is the value to signal.\n[](#_description)Description\n----------\n\nValid Usage\n\n* []() VUID-VkSemaphoreSignalInfo-semaphore-03257  \n  `semaphore` **must** have been created with a [`crate::vk::SemaphoreType`] of[`crate::vk::SemaphoreType::TIMELINE`]\n\n* []() VUID-VkSemaphoreSignalInfo-value-03258  \n  `value` **must** have a value greater than the current value of the\n  semaphore\n\n* []() VUID-VkSemaphoreSignalInfo-value-03259  \n  `value` **must** be less than the value of any pending semaphore signal\n  operations\n\n* []() VUID-VkSemaphoreSignalInfo-value-03260  \n  `value` **must** have a value which does not differ from the current\n  value of the semaphore or the value of any outstanding semaphore wait or\n  signal operation on `semaphore` by more than[`maxTimelineSemaphoreValueDifference`](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#limits-maxTimelineSemaphoreValueDifference)\n\nValid Usage (Implicit)\n\n* []() VUID-VkSemaphoreSignalInfo-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::SEMAPHORE_SIGNAL_INFO`]\n\n* []() VUID-VkSemaphoreSignalInfo-pNext-pNext  \n  `pNext` **must** be `NULL`\n\n* []() VUID-VkSemaphoreSignalInfo-semaphore-parameter  \n  `semaphore` **must** be a valid [`crate::vk::Semaphore`] handle\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Semaphore`], [`crate::vk::StructureType`], [`crate::vk::PFN_vkSignalSemaphore`], [`crate::vk::PFN_vkSignalSemaphore`]\n"]
#[doc(alias = "VkSemaphoreSignalInfoKHR")]
#[allow(non_camel_case_types)]
pub type SemaphoreSignalInfoKHRBuilder<'a> = crate::vk1_2::SemaphoreSignalInfoBuilder<'a>;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkGetSemaphoreCounterValueKHR.html)) · Alias <br/> vkGetSemaphoreCounterValue - Query the current state of a timeline semaphore\n[](#_c_specification)C Specification\n----------\n\nTo query the current counter value of a semaphore created with a[`crate::vk::SemaphoreType`] of [`crate::vk::SemaphoreType::TIMELINE`] from the host,\ncall:\n\n```\n// Provided by VK_VERSION_1_2\nVkResult vkGetSemaphoreCounterValue(\n    VkDevice                                    device,\n    VkSemaphore                                 semaphore,\n    uint64_t*                                   pValue);\n```\n\nor the equivalent command\n\n```\n// Provided by VK_KHR_timeline_semaphore\nVkResult vkGetSemaphoreCounterValueKHR(\n    VkDevice                                    device,\n    VkSemaphore                                 semaphore,\n    uint64_t*                                   pValue);\n```\n[](#_parameters)Parameters\n----------\n\n* `device` is the logical device that owns the semaphore.\n\n* `semaphore` is the handle of the semaphore to query.\n\n* `pValue` is a pointer to a 64-bit integer value in which the current\n  counter value of the semaphore is returned.\n[](#_description)Description\n----------\n\n|   |Note<br/><br/>If a [queue submission](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#devsandqueues-submission) command is pending<br/>execution, then the value returned by this command **may** immediately be out<br/>of date.|\n|---|---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n\nValid Usage\n\n* []() VUID-vkGetSemaphoreCounterValue-semaphore-03255  \n  `semaphore` **must** have been created with a [`crate::vk::SemaphoreType`] of[`crate::vk::SemaphoreType::TIMELINE`]\n\nValid Usage (Implicit)\n\n* []() VUID-vkGetSemaphoreCounterValue-device-parameter  \n  `device` **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkGetSemaphoreCounterValue-semaphore-parameter  \n  `semaphore` **must** be a valid [`crate::vk::Semaphore`] handle\n\n* []() VUID-vkGetSemaphoreCounterValue-pValue-parameter  \n  `pValue` **must** be a valid pointer to a `uint64_t` value\n\n* []() VUID-vkGetSemaphoreCounterValue-semaphore-parent  \n  `semaphore` **must** have been created, allocated, or retrieved from `device`\n\nReturn Codes\n\nOn success, this command returns\n\n* [`crate::vk::Result::SUCCESS`]\n\nOn failure, this command returns\n\n* [`crate::vk::Result::ERROR_OUT_OF_HOST_MEMORY`]\n\n* [`crate::vk::Result::ERROR_OUT_OF_DEVICE_MEMORY`]\n\n* [`crate::vk::Result::ERROR_DEVICE_LOST`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Device`], [`crate::vk::Semaphore`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkGetSemaphoreCounterValueKHR = crate::vk1_2::PFN_vkGetSemaphoreCounterValue;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkWaitSemaphoresKHR.html)) · Alias <br/> vkWaitSemaphores - Wait for timeline semaphores on the host\n[](#_c_specification)C Specification\n----------\n\nTo wait for a set of semaphores created with a [`crate::vk::SemaphoreType`] of[`crate::vk::SemaphoreType::TIMELINE`] to reach particular counter values on the\nhost, call:\n\n```\n// Provided by VK_VERSION_1_2\nVkResult vkWaitSemaphores(\n    VkDevice                                    device,\n    const VkSemaphoreWaitInfo*                  pWaitInfo,\n    uint64_t                                    timeout);\n```\n\nor the equivalent command\n\n```\n// Provided by VK_KHR_timeline_semaphore\nVkResult vkWaitSemaphoresKHR(\n    VkDevice                                    device,\n    const VkSemaphoreWaitInfo*                  pWaitInfo,\n    uint64_t                                    timeout);\n```\n[](#_parameters)Parameters\n----------\n\n* `device` is the logical device that owns the semaphores.\n\n* `pWaitInfo` is a pointer to a [`crate::vk::SemaphoreWaitInfo`] structure\n  containing information about the wait condition.\n\n* `timeout` is the timeout period in units of nanoseconds.`timeout` is adjusted to the closest value allowed by the\n  implementation-dependent timeout accuracy, which **may** be substantially\n  longer than one nanosecond, and **may** be longer than the requested\n  period.\n[](#_description)Description\n----------\n\nIf the condition is satisfied when [`crate::vk::PFN_vkWaitSemaphores`] is called, then[`crate::vk::PFN_vkWaitSemaphores`] returns immediately.\nIf the condition is not satisfied at the time [`crate::vk::PFN_vkWaitSemaphores`] is\ncalled, then [`crate::vk::PFN_vkWaitSemaphores`] will block and wait until the condition\nis satisfied or the `timeout` has expired, whichever is sooner.\n\nIf `timeout` is zero, then [`crate::vk::PFN_vkWaitSemaphores`] does not wait, but\nsimply returns information about the current state of the semaphores.[`crate::vk::Result::TIMEOUT`] will be returned in this case if the condition is not\nsatisfied, even though no actual wait was performed.\n\nIf the condition is satisfied before the `timeout` has expired,[`crate::vk::PFN_vkWaitSemaphores`] returns [`crate::vk::Result::SUCCESS`].\nOtherwise, [`crate::vk::PFN_vkWaitSemaphores`] returns [`crate::vk::Result::TIMEOUT`] after the`timeout` has expired.\n\nIf device loss occurs (see [Lost Device](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#devsandqueues-lost-device)) before\nthe timeout has expired, [`crate::vk::PFN_vkWaitSemaphores`] **must** return in finite time\nwith either [`crate::vk::Result::SUCCESS`] or [`crate::vk::Result::ERROR_DEVICE_LOST`].\n\nValid Usage (Implicit)\n\n* []() VUID-vkWaitSemaphores-device-parameter  \n  `device` **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkWaitSemaphores-pWaitInfo-parameter  \n  `pWaitInfo` **must** be a valid pointer to a valid [`crate::vk::SemaphoreWaitInfo`] structure\n\nReturn Codes\n\nOn success, this command returns\n\n* [`crate::vk::Result::SUCCESS`]\n\n* [`crate::vk::Result::TIMEOUT`]\n\nOn failure, this command returns\n\n* [`crate::vk::Result::ERROR_OUT_OF_HOST_MEMORY`]\n\n* [`crate::vk::Result::ERROR_OUT_OF_DEVICE_MEMORY`]\n\n* [`crate::vk::Result::ERROR_DEVICE_LOST`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Device`], [`crate::vk::SemaphoreWaitInfo`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkWaitSemaphoresKHR = crate::vk1_2::PFN_vkWaitSemaphores;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkSignalSemaphoreKHR.html)) · Alias <br/> vkSignalSemaphore - Signal a timeline semaphore on the host\n[](#_c_specification)C Specification\n----------\n\nTo signal a semaphore created with a [`crate::vk::SemaphoreType`] of[`crate::vk::SemaphoreType::TIMELINE`] with a particular counter value, on the\nhost, call:\n\n```\n// Provided by VK_VERSION_1_2\nVkResult vkSignalSemaphore(\n    VkDevice                                    device,\n    const VkSemaphoreSignalInfo*                pSignalInfo);\n```\n\nor the equivalent command\n\n```\n// Provided by VK_KHR_timeline_semaphore\nVkResult vkSignalSemaphoreKHR(\n    VkDevice                                    device,\n    const VkSemaphoreSignalInfo*                pSignalInfo);\n```\n[](#_parameters)Parameters\n----------\n\n* `device` is the logical device that owns the semaphore.\n\n* `pSignalInfo` is a pointer to a [`crate::vk::SemaphoreSignalInfo`]structure containing information about the signal operation.\n[](#_description)Description\n----------\n\nWhen [`crate::vk::PFN_vkSignalSemaphore`] is executed on the host, it defines and\nimmediately executes a [*semaphore\nsignal operation*](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#synchronization-semaphores-signaling) which sets the timeline semaphore to the given value.\n\nThe first synchronization scope is defined by the host execution model, but\nincludes execution of [`crate::vk::PFN_vkSignalSemaphore`] on the host and anything that\nhappened-before it.\n\nThe second synchronization scope is empty.\n\nValid Usage (Implicit)\n\n* []() VUID-vkSignalSemaphore-device-parameter  \n  `device` **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkSignalSemaphore-pSignalInfo-parameter  \n  `pSignalInfo` **must** be a valid pointer to a valid [`crate::vk::SemaphoreSignalInfo`] structure\n\nReturn Codes\n\nOn success, this command returns\n\n* [`crate::vk::Result::SUCCESS`]\n\nOn failure, this command returns\n\n* [`crate::vk::Result::ERROR_OUT_OF_HOST_MEMORY`]\n\n* [`crate::vk::Result::ERROR_OUT_OF_DEVICE_MEMORY`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Device`], [`crate::vk::SemaphoreSignalInfo`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkSignalSemaphoreKHR = crate::vk1_2::PFN_vkSignalSemaphore;
#[doc = "Provided by [`crate::extensions::khr_timeline_semaphore`]"]
impl crate::vk1_0::StructureType {
    pub const PHYSICAL_DEVICE_TIMELINE_SEMAPHORE_FEATURES_KHR: Self = Self::PHYSICAL_DEVICE_TIMELINE_SEMAPHORE_FEATURES;
    pub const PHYSICAL_DEVICE_TIMELINE_SEMAPHORE_PROPERTIES_KHR: Self = Self::PHYSICAL_DEVICE_TIMELINE_SEMAPHORE_PROPERTIES;
    pub const SEMAPHORE_TYPE_CREATE_INFO_KHR: Self = Self::SEMAPHORE_TYPE_CREATE_INFO;
    pub const TIMELINE_SEMAPHORE_SUBMIT_INFO_KHR: Self = Self::TIMELINE_SEMAPHORE_SUBMIT_INFO;
    pub const SEMAPHORE_WAIT_INFO_KHR: Self = Self::SEMAPHORE_WAIT_INFO;
    pub const SEMAPHORE_SIGNAL_INFO_KHR: Self = Self::SEMAPHORE_SIGNAL_INFO;
}
#[doc = "Provided by [`crate::extensions::khr_timeline_semaphore`]"]
impl crate::vk1_2::SemaphoreType {
    pub const BINARY_KHR: Self = Self::BINARY;
    pub const TIMELINE_KHR: Self = Self::TIMELINE;
}
#[doc = "Provided by [`crate::extensions::khr_timeline_semaphore`]"]
impl crate::vk1_2::SemaphoreWaitFlagBits {
    pub const ANY_KHR: Self = Self::ANY;
}
#[doc = "Provided by [`crate::extensions::khr_timeline_semaphore`]"]
impl crate::DeviceLoader {
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkGetSemaphoreCounterValueKHR.html)) · Function <br/> vkGetSemaphoreCounterValue - Query the current state of a timeline semaphore\n[](#_c_specification)C Specification\n----------\n\nTo query the current counter value of a semaphore created with a[`crate::vk::SemaphoreType`] of [`crate::vk::SemaphoreType::TIMELINE`] from the host,\ncall:\n\n```\n// Provided by VK_VERSION_1_2\nVkResult vkGetSemaphoreCounterValue(\n    VkDevice                                    device,\n    VkSemaphore                                 semaphore,\n    uint64_t*                                   pValue);\n```\n\nor the equivalent command\n\n```\n// Provided by VK_KHR_timeline_semaphore\nVkResult vkGetSemaphoreCounterValueKHR(\n    VkDevice                                    device,\n    VkSemaphore                                 semaphore,\n    uint64_t*                                   pValue);\n```\n[](#_parameters)Parameters\n----------\n\n* `device` is the logical device that owns the semaphore.\n\n* `semaphore` is the handle of the semaphore to query.\n\n* `pValue` is a pointer to a 64-bit integer value in which the current\n  counter value of the semaphore is returned.\n[](#_description)Description\n----------\n\n|   |Note<br/><br/>If a [queue submission](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#devsandqueues-submission) command is pending<br/>execution, then the value returned by this command **may** immediately be out<br/>of date.|\n|---|---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n\nValid Usage\n\n* []() VUID-vkGetSemaphoreCounterValue-semaphore-03255  \n  `semaphore` **must** have been created with a [`crate::vk::SemaphoreType`] of[`crate::vk::SemaphoreType::TIMELINE`]\n\nValid Usage (Implicit)\n\n* []() VUID-vkGetSemaphoreCounterValue-device-parameter  \n  `device` **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkGetSemaphoreCounterValue-semaphore-parameter  \n  `semaphore` **must** be a valid [`crate::vk::Semaphore`] handle\n\n* []() VUID-vkGetSemaphoreCounterValue-pValue-parameter  \n  `pValue` **must** be a valid pointer to a `uint64_t` value\n\n* []() VUID-vkGetSemaphoreCounterValue-semaphore-parent  \n  `semaphore` **must** have been created, allocated, or retrieved from `device`\n\nReturn Codes\n\nOn success, this command returns\n\n* [`crate::vk::Result::SUCCESS`]\n\nOn failure, this command returns\n\n* [`crate::vk::Result::ERROR_OUT_OF_HOST_MEMORY`]\n\n* [`crate::vk::Result::ERROR_OUT_OF_DEVICE_MEMORY`]\n\n* [`crate::vk::Result::ERROR_DEVICE_LOST`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Device`], [`crate::vk::Semaphore`]\n"]
    #[doc(alias = "vkGetSemaphoreCounterValueKHR")]
    pub unsafe fn get_semaphore_counter_value_khr(&self, semaphore: crate::vk1_0::Semaphore) -> crate::utils::VulkanResult<u64> {
        let _function = self.get_semaphore_counter_value_khr.expect(crate::NOT_LOADED_MESSAGE);
        let mut value = Default::default();
        let _return = _function(self.handle, semaphore as _, &mut value);
        crate::utils::VulkanResult::new(_return, value)
    }
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkWaitSemaphoresKHR.html)) · Function <br/> vkWaitSemaphores - Wait for timeline semaphores on the host\n[](#_c_specification)C Specification\n----------\n\nTo wait for a set of semaphores created with a [`crate::vk::SemaphoreType`] of[`crate::vk::SemaphoreType::TIMELINE`] to reach particular counter values on the\nhost, call:\n\n```\n// Provided by VK_VERSION_1_2\nVkResult vkWaitSemaphores(\n    VkDevice                                    device,\n    const VkSemaphoreWaitInfo*                  pWaitInfo,\n    uint64_t                                    timeout);\n```\n\nor the equivalent command\n\n```\n// Provided by VK_KHR_timeline_semaphore\nVkResult vkWaitSemaphoresKHR(\n    VkDevice                                    device,\n    const VkSemaphoreWaitInfo*                  pWaitInfo,\n    uint64_t                                    timeout);\n```\n[](#_parameters)Parameters\n----------\n\n* `device` is the logical device that owns the semaphores.\n\n* `pWaitInfo` is a pointer to a [`crate::vk::SemaphoreWaitInfo`] structure\n  containing information about the wait condition.\n\n* `timeout` is the timeout period in units of nanoseconds.`timeout` is adjusted to the closest value allowed by the\n  implementation-dependent timeout accuracy, which **may** be substantially\n  longer than one nanosecond, and **may** be longer than the requested\n  period.\n[](#_description)Description\n----------\n\nIf the condition is satisfied when [`crate::vk::PFN_vkWaitSemaphores`] is called, then[`crate::vk::PFN_vkWaitSemaphores`] returns immediately.\nIf the condition is not satisfied at the time [`crate::vk::PFN_vkWaitSemaphores`] is\ncalled, then [`crate::vk::PFN_vkWaitSemaphores`] will block and wait until the condition\nis satisfied or the `timeout` has expired, whichever is sooner.\n\nIf `timeout` is zero, then [`crate::vk::PFN_vkWaitSemaphores`] does not wait, but\nsimply returns information about the current state of the semaphores.[`crate::vk::Result::TIMEOUT`] will be returned in this case if the condition is not\nsatisfied, even though no actual wait was performed.\n\nIf the condition is satisfied before the `timeout` has expired,[`crate::vk::PFN_vkWaitSemaphores`] returns [`crate::vk::Result::SUCCESS`].\nOtherwise, [`crate::vk::PFN_vkWaitSemaphores`] returns [`crate::vk::Result::TIMEOUT`] after the`timeout` has expired.\n\nIf device loss occurs (see [Lost Device](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#devsandqueues-lost-device)) before\nthe timeout has expired, [`crate::vk::PFN_vkWaitSemaphores`] **must** return in finite time\nwith either [`crate::vk::Result::SUCCESS`] or [`crate::vk::Result::ERROR_DEVICE_LOST`].\n\nValid Usage (Implicit)\n\n* []() VUID-vkWaitSemaphores-device-parameter  \n  `device` **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkWaitSemaphores-pWaitInfo-parameter  \n  `pWaitInfo` **must** be a valid pointer to a valid [`crate::vk::SemaphoreWaitInfo`] structure\n\nReturn Codes\n\nOn success, this command returns\n\n* [`crate::vk::Result::SUCCESS`]\n\n* [`crate::vk::Result::TIMEOUT`]\n\nOn failure, this command returns\n\n* [`crate::vk::Result::ERROR_OUT_OF_HOST_MEMORY`]\n\n* [`crate::vk::Result::ERROR_OUT_OF_DEVICE_MEMORY`]\n\n* [`crate::vk::Result::ERROR_DEVICE_LOST`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Device`], [`crate::vk::SemaphoreWaitInfo`]\n"]
    #[doc(alias = "vkWaitSemaphoresKHR")]
    pub unsafe fn wait_semaphores_khr(&self, wait_info: &crate::vk1_2::SemaphoreWaitInfo, timeout: u64) -> crate::utils::VulkanResult<()> {
        let _function = self.wait_semaphores_khr.expect(crate::NOT_LOADED_MESSAGE);
        let _return = _function(self.handle, wait_info as _, timeout as _);
        crate::utils::VulkanResult::new(_return, ())
    }
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkSignalSemaphoreKHR.html)) · Function <br/> vkSignalSemaphore - Signal a timeline semaphore on the host\n[](#_c_specification)C Specification\n----------\n\nTo signal a semaphore created with a [`crate::vk::SemaphoreType`] of[`crate::vk::SemaphoreType::TIMELINE`] with a particular counter value, on the\nhost, call:\n\n```\n// Provided by VK_VERSION_1_2\nVkResult vkSignalSemaphore(\n    VkDevice                                    device,\n    const VkSemaphoreSignalInfo*                pSignalInfo);\n```\n\nor the equivalent command\n\n```\n// Provided by VK_KHR_timeline_semaphore\nVkResult vkSignalSemaphoreKHR(\n    VkDevice                                    device,\n    const VkSemaphoreSignalInfo*                pSignalInfo);\n```\n[](#_parameters)Parameters\n----------\n\n* `device` is the logical device that owns the semaphore.\n\n* `pSignalInfo` is a pointer to a [`crate::vk::SemaphoreSignalInfo`]structure containing information about the signal operation.\n[](#_description)Description\n----------\n\nWhen [`crate::vk::PFN_vkSignalSemaphore`] is executed on the host, it defines and\nimmediately executes a [*semaphore\nsignal operation*](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#synchronization-semaphores-signaling) which sets the timeline semaphore to the given value.\n\nThe first synchronization scope is defined by the host execution model, but\nincludes execution of [`crate::vk::PFN_vkSignalSemaphore`] on the host and anything that\nhappened-before it.\n\nThe second synchronization scope is empty.\n\nValid Usage (Implicit)\n\n* []() VUID-vkSignalSemaphore-device-parameter  \n  `device` **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkSignalSemaphore-pSignalInfo-parameter  \n  `pSignalInfo` **must** be a valid pointer to a valid [`crate::vk::SemaphoreSignalInfo`] structure\n\nReturn Codes\n\nOn success, this command returns\n\n* [`crate::vk::Result::SUCCESS`]\n\nOn failure, this command returns\n\n* [`crate::vk::Result::ERROR_OUT_OF_HOST_MEMORY`]\n\n* [`crate::vk::Result::ERROR_OUT_OF_DEVICE_MEMORY`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Device`], [`crate::vk::SemaphoreSignalInfo`]\n"]
    #[doc(alias = "vkSignalSemaphoreKHR")]
    pub unsafe fn signal_semaphore_khr(&self, signal_info: &crate::vk1_2::SemaphoreSignalInfo) -> crate::utils::VulkanResult<()> {
        let _function = self.signal_semaphore_khr.expect(crate::NOT_LOADED_MESSAGE);
        let _return = _function(self.handle, signal_info as _);
        crate::utils::VulkanResult::new(_return, ())
    }
}
